<script lang="ts">
import Vue from 'vue';
import FeaturesProductsCategoryPricingPills from './features-product-category-pricing-pills.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'FeaturesProductsCategoryCards',
  components: {
    FeaturesProductsCategoryPricingPills,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Array,
      required: true,
      default: null,
    },
    columnSize: {
      type: Number,
      required: true,
    },
    currentCategory: {
      type: String,
      required: true,
    },
    imageBasePath: {
      type: String,
      required: false,
      default: '',
    },
    tabTitle: {
      type: String,
      required: false,
      default: undefined,
    },
    hasStageCategory: {
      type: Boolean,
      required: false,
      default: true,
    },
    cardsDataGaLocation: {
      type: String,
      required: false,
      default: undefined,
    },
  },
  data() {
    return {
      modal: {
        open: false,
        video: false,
      },
      imageSrc: '',
      imageAlt: '',
      videoUrl: '',
    };
  },
  methods: {
    openModal(url: any, alt: any) {
      this.modal.open = true;
      this.imageSrc = url;
      this.imageAlt = alt;
    },
    closeModal() {
      this.modal.open = false;
      this.modal.video = false;
    },
    openVideoModal(video: any) {
      this.modal.video = true;
      this.modal.open = true;
      this.videoUrl = video;
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    imgPlaceholder(e: any) {
      const imageError = e;
      imageError.target.classList.add(
        'features-product-category__image--placeholder',
      );
      imageError.target.src =
        '/nuxt-images/resources/fallback/img-fallback-cards-infinity.png';
    },
  },
});
</script>

<template>
  <section class="slp-mb-96">
    <SlpRow>
      <SlpColumn
        v-for="(productCategory, index) in data"
        :key="`${productCategory.title}-${index}`"
        :cols="columnSize"
        class="slp-mb-16"
      >
        <client-only>
          <div class="features-product-category">
            <div
              class="slp-card features-product-category__content"
              :class="{
                'features-product-category__content--opacity':
                  productCategory.with_opacity,
              }"
            >
              <SlpTypography
                tag="h3"
                variant="body2"
                class="features-product-category__category slp-mb-24"
              >
                {{ currentCategory }}
              </SlpTypography>
              <div class="features-product-category__image-wrapper slp-mb-24">
                <img
                  loading="lazy"
                  :src="`${imageBasePath}${productCategory.screenshot_url}`"
                  :alt="`image for ${productCategory.title}`"
                  class="features-product-category__image"
                  @error="imgPlaceholder"
                  @click="
                    openModal(
                      productCategory.screenshot_url,
                      productCategory.title,
                    )
                  "
                />
              </div>
              <SlpTypography tag="h4" variant="body1-bold" class="slp-mb-16">{{
                productCategory.title
              }}</SlpTypography>
              <FeaturesProductsCategoryPricingPills
                :data="productCategory"
                :tab-title="tabTitle"
                :pills-data-ga-location="cardsDataGaLocation"
                :current-category="currentCategory"
                :has-stage-category="hasStageCategory"
              />
              <div
                class="slp-text-body-1"
                v-html="$md.render(productCategory.description)"
              ></div>
              <div class="features-product-category__cta">
                <SlpButton
                  v-if="productCategory.video"
                  variant="ghost"
                  class="features-product-category__cta__video-button"
                  :aria-label="productCategory?.link?.data_ga_name || ''"
                  :data-ga-name="productCategory?.link?.data_ga_name || ''"
                  :data-ga-location="
                    productCategory?.link?.data_ga_location || ''
                  "
                  @click.native="openVideoModal(productCategory.video)"
                >
                  <SlpIcon
                    class="features-product-category__icon"
                    name="play-circle"
                    variant="marketing"
                    size="md"
                    slp-color="text-link-100"
                  />
                </SlpButton>
                <SlpButton
                  variant="tertiary"
                  :aria-label="
                    productCategory.data_ga_name
                      ? productCategory.data_ga_name
                      : productCategory.link_description
                  "
                  :href="productCategory.link ? productCategory.link : null"
                  :data-ga-features="tabTitle?.toLowerCase() ?? null"
                  :data-ga-features-sub="
                    tabTitle && hasStageCategory
                      ? currentCategory.toLowerCase()
                      : null
                  "
                  :data-ga-features-sub-card="
                    tabTitle ? productCategory.title.toLowerCase() : null
                  "
                  :data-ga-name="productCategory?.link?.text ?? 'Documentation'"
                  :data-ga-location="
                    cardsDataGaLocation ??
                    (tabTitle ? 'features content' : null)
                  "
                  class="features-product-category__cta-text"
                >
                  <SlpTypography
                    tag="span"
                    variant="body3-bold"
                    v-html="productCategory?.link?.text ?? 'Documentation'"
                  >
                  </SlpTypography>
                  <SlpIcon
                    class="slp-ml-8"
                    name="chevron-lg-right"
                    variant="product"
                    alt="Chevron Right Icon"
                  />
                </SlpButton>
              </div>
            </div>
          </div>
        </client-only>
      </SlpColumn>
    </SlpRow>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <SlpContainer>
          <lite-vimeo
            v-if="modal.video"
            ref="video"
            :videoid="getVimeoVideoId(createVideoSource(videoUrl))"
            class="features-product-category__modal-video"
            autoplay
          ></lite-vimeo>

          <img
            v-else
            :src="`${imageBasePath}${imageSrc}`"
            :alt="`image for ${imageAlt}`"
            class="slp-mb-24 features-product-category__modal-img"
            @error="imgPlaceholder"
          />
        </SlpContainer>
      </template>
    </SolutionsVideoModal>
  </section>
</template>

<style scoped lang="scss">
.features-product-category {
  color: inherit;
  height: 100%;

  &__content {
    border-radius: $spacing-4;
    padding: $spacing-32;
    display: flex;
    flex-direction: column;
    height: 100%;
    transition: all 0.5s ease-in-out;

    @media (min-width: $breakpoint-md) {
      margin-left: $spacing-16;
    }

    &--opacity {
      opacity: 0.4 !important;
    }
  }

  &__image {
    cursor: zoom-in;
    width: 100%;
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    margin: auto 0;
    &--placeholder {
      pointer-events: none;
    }
  }

  &__image-wrapper {
    padding-bottom: 58%;
    position: relative;
    overflow: hidden;

    &::before {
      content: '';
      background: $color-surface-800;
      position: absolute;
      width: 100%;
      height: 100%;
      left: 0;
      top: 0;
      border-radius: $spacing-4;
    }
  }

  &__cta {
    padding: $spacing-24 0 0 0;
    margin: auto 0 0 0;

    &-text {
      padding-left: 0;
      cursor: pointer;
    }

    a,
    button {
      color: $color-text-link-100;
    }

    a {
      &:hover,
      &:focus,
      &:active {
        text-decoration-color: $color-text-link-100;
      }
    }

    &__video-button {
      border-right: 1px solid $color-surface-600;
      border-radius: 0;
      min-width: $spacing-24;
      padding: 0 $spacing-16 0 0;
      width: auto;
    }
  }

  &__icon {
    width: $spacing-24;
    height: $spacing-24;
  }

  &__modal-img {
    width: 100%;
  }
  &__modal-video {
    border-radius: $border-radius-4;
    border: none;
    width: 330px;
    height: 200px;
    @media (min-width: $breakpoint-md) {
      width: 700px;
      height: 390px;
    }
    @media (min-width: $breakpoint-lg) {
      width: 920px;
      height: 516px;
    }
  }
}
</style>
